package gallery
{
	import flash.display.Loader;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.URLRequest;
	
	import preloader.SimpleLinePreloader;
	
	
	public class ImageItem extends Sprite implements IGalleryItem
	{
		private var imageLoader:Loader;
		private var imagePath:String;
		private var loading:Boolean;
		private var imageWidth:Number;
		private var imageHeight:Number;
		private var imagePreLoader:SimpleLinePreloader;
		public function ImageItem(path:String,width:Number,height:Number,preLoader:SimpleLinePreloader = null)
		{
			super();
			imagePath = path;
			imageWidth = width;
			imageHeight = height;
			imagePreLoader = preLoader;
			var bg:Shape = new Shape();
			bg.graphics.lineStyle(0, 0, 0);
			bg.graphics.beginFill(0xFFFFFF, 1);
			bg.graphics.drawRect(0, 0, imageWidth, imageHeight);
			bg.graphics.endFill();
			addChild(bg);
			
			loading = false;
			imageLoader = new Loader();
			imageLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,readyImage);
		}
		public function load():void{
			if (imagePreLoader != null){
				imagePreLoader.setItem(imageLoader);
			}
			imageLoader.load(new URLRequest(imagePath));
			loading = true;
		}
		public function isLoading():Boolean{
			return loading;
		}
		public function stopLoading():void{
			imageLoader.close();
			imageLoader.contentLoaderInfo.removeEventListener(Event.COMPLETE,readyImage);
		}
		private function readyImage(e:Event):void
		{
			loading = false;
			imageLoader.contentLoaderInfo.removeEventListener(Event.COMPLETE,readyImage);
			
			if (imagePreLoader != null){
				imagePreLoader.removeItem(imageLoader);
			}
			
			var sc:Number = Math.max(imageWidth / imageLoader.width, imageHeight / imageLoader.height);
			imageLoader.scaleX = imageLoader.scaleY = sc;
			imageLoader.x = (imageWidth - imageLoader.width) / 2;
			imageLoader.y = (imageHeight - imageLoader.height) / 2;
			addChild(imageLoader);
			this.cacheAsBitmap = true;
			
			dispatchEvent(new Event("ItemReady"));
			
		}
	}
}