﻿package transitions 
{
	import caurina.transitions.Tweener;
	
	import flash.display.Sprite;
	/**
	$(CBI)* ...
	$(CBI)* @author ...
	$(CBI)*/
	public class BlindsTransition  extends Transition
	{
		
		
		private var current:Sprite;
		private var old:Sprite;
		private var type:String;
		private var amount:Number;
		private var barSprite:Sprite;
		private var barOrder:Array;
		private var tweenObject:Object;
		private var oldn:Number;
		private var barW:Number;
		private var barH:Number;
		public function BlindsTransition(current:Sprite,old:Sprite,subtype:String=TransitionManager.HORIZONTAL,amount:Number=10,effect:Number=0,delay:Number=3,time:Number=1,startAlpha:Number=1) 
		{
			this.current = current;
			this.old = old;
			
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);	
			
			
			var curMask:Sprite = new Sprite();
			current.addChild(curMask);
			current.mask = curMask;
			current.alpha = startAlpha;
			var d:Number;
			var t:Number = (delay*time)/(amount+delay-1);
			if (subtype == TransitionManager.HORIZONTAL) {
				var height:Number = TransitionManager.transitionAreaHeight / amount;
				for (var i:uint = 0; i < amount; i++) {
					var blind:Sprite = new Sprite();
					blind.graphics.lineStyle(0, 0, 0);
					blind.graphics.beginFill(0);
					blind.graphics.drawRect(0, 0, TransitionManager.transitionAreaWidth, height);
					blind.graphics.endFill();
					blind.y = i * height;
					curMask.addChild(blind);
					blind.scaleY = 0;
					if(effect==1){
						d = i * time / (amount+delay-1);
						Tweener.addTween(blind, { scaleY:1, delay:d, time:t, transition:"linear"});
					}else{
						Tweener.addTween(blind, { scaleY:1, time:time, transition:"linear"});
					}
				}
			}else if (subtype == TransitionManager.VERTICAL) {
				var width:Number = TransitionManager.transitionAreaWidth / amount;
				for (i = 0; i < amount; i++) {
					blind = new Sprite();
					blind.graphics.lineStyle(0, 0, 0);
					blind.graphics.beginFill(0);
					blind.graphics.drawRect(0, 0, width, TransitionManager.transitionAreaHeight);
					blind.graphics.endFill();
					blind.x = i * width;
					curMask.addChild(blind);
					blind.scaleX = 0;
					if(effect==1){
						d = i * time / (amount+delay-1);
						Tweener.addTween(blind, { scaleX:1, delay:d, time:t, transition:"linear"});
					}else{
						Tweener.addTween(blind, { scaleX:1, time:time, transition:"linear"});
					}
				}
			}
			Tweener.addTween(current,{alpha:1, time:time, transition:"linear",onComplete:transitionCompleted});
			
		}
		private function transitionCompleted():void {
			current.removeChild(current.mask);
			current.mask = null;
			current.alpha = 1;
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			var curMask:Sprite = Sprite(current.mask);
			for (var i:uint; i < curMask.numChildren; i++) {
				Tweener.removeTweens(curMask.getChildAt(i));
			}
			Tweener.removeTweens(current);
			transitionCompleted();
		}
		
	}
	
}