package transitions
{
	import caurina.transitions.Tweener;
	import caurina.transitions.properties.FilterShortcuts;
	
	import flash.display.Sprite;
	import flash.filters.BlurFilter;

	public class BlurTransition extends Transition
	{
		private var current:Sprite;
		private var old:Sprite;
		public function BlurTransition(current:Sprite,old:Sprite,blurX:Number=20,blurY:Number=20,quality:Number=2,time:Number=1) 
		{
			this.current = current;
			this.old = old;
			
			FilterShortcuts.init();
			
			this.current.alpha = 0;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			current.filters = [new BlurFilter(blurX,blurY,quality)];
			Tweener.addTween(old,{alpha:0,_Blur_blurX:blurX,_Blur_blurY:blurY,time:time/2,_Blur_quality:quality,transition:"easeInCubic"});
			Tweener.addTween(current,{alpha:1,time:time/2,transition:"linear"});
			Tweener.addTween(current,{_Blur_blurX:0,_Blur_blurY:0,delay:time/2,time:time/2,_Blur_quality:quality,transition:"easeOutCubic", onComplete:transitionCompleted});
		}
		private function transitionCompleted():void {
			current.filters = [];
			old.filters = [];
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(old);
			Tweener.removeTweens(current);
			current.alpha = 1;
			transitionCompleted();
		}
	}
}