﻿package transitions 
{
	import caurina.transitions.Tweener;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	
	public class FadeTransition extends Transition
	{
		private var current:Sprite;
		private var old:Sprite;
		private var fadeSprite:Sprite;
		public function FadeTransition(current:Sprite,old:Sprite,color:uint=0xFFFFFF,time:Number=1) 
		{
			this.current = current;
			this.old = old;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			current.alpha = 0;
			fadeSprite = new Sprite();
			fadeSprite.graphics.lineStyle(0, 0, 0);
			fadeSprite.graphics.beginFill(color);
			fadeSprite.graphics.drawRect(0, 0, Math.min(TransitionManager.transitionAreaWidth,current.width), Math.min(TransitionManager.transitionAreaHeight,current.height));
			fadeSprite.graphics.endFill();
			fadeSprite.alpha = 0.5;
			current.addChild(fadeSprite);
			
			Tweener.addTween(old, { alpha:0.5, time:time / 2, transition:"linear" } );
			Tweener.addTween(fadeSprite, { alpha:0,delay:time / 2, time:time/2,transition:"linear" , onComplete:transitionCompleted } );
			Tweener.addTween(current, { alpha:1, time:time,transition:"linear"  } );
		}
		private function transitionCompleted():void {
			current.alpha = 1;
			current.removeChild(fadeSprite);
			if (old) {
				old.visible = false;
				old.alpha = 1;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			if(old)
				Tweener.removeTweens(old);
			Tweener.removeTweens(fadeSprite);
			transitionCompleted();
		}
		
	}
	
}