﻿package transitions 
{
	import caurina.transitions.Tweener;
	import flash.display.Sprite;
	/**
	$(CBI)* ...
	$(CBI)* @author ...
	$(CBI)*/
	public class RandomBarsTransition  extends Transition
	{
		
		
		private var current:Sprite;
		private var old:Sprite;
		private var type:String;
		private var amount:Number;
		private var barSprite:Sprite;
		private var barOrder:Array;
		private var tweenObject:Object;
		private var oldn:Number;
		private var barW:Number;
		private var barH:Number;
		public function RandomBarsTransition(current:Sprite,old:Sprite,subtype:String=TransitionManager.HORIZONTAL,amount:Number=100,time:Number=1) 
		{
			this.current = current;
			this.old = old;
			this.amount = amount;
			this.type = subtype;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
				
			
			createBarOrder();
			
			barSprite = new Sprite();
			if (type == TransitionManager.HORIZONTAL) {
				barW = TransitionManager.transitionAreaWidth;
				barH = TransitionManager.transitionAreaHeight / amount;
				barSprite.graphics.lineStyle(barH, 0x000000);
			}else {
				barW = TransitionManager.transitionAreaWidth/ amount;
				barH = TransitionManager.transitionAreaHeight;
				barSprite.graphics.lineStyle(barW, 0x000000);
			}
			
			
			
			current.addChild(barSprite);
			barSprite.cacheAsBitmap = true;
			current.mask = barSprite;
			
			oldn = 0;
			tweenObject = new Object();
			tweenObject.n = 0;
			
			Tweener.addTween(tweenObject, { n:amount, time:time,transition:"linear",onUpdate:updateBar,onComplete:transitionCompleted } );
			
			
		}
		private function createBarOrder():void {
			barOrder = new Array(amount);
			for(var i:uint=0;i<amount;i++){
				barOrder[i]=i;
			}
			for(i=0;i<amount*2;i++){
				var a:Number = Math.floor(Math.random()*amount);
				var b:Number = Math.floor(Math.random()*amount);
				var t:Number = barOrder[a];
				barOrder[a] = barOrder[b];
				barOrder[b] = t;
			}
		}
		private function updateBar():void {
			for (var i:uint = oldn; i < tweenObject.n; i++) {
				if (type == TransitionManager.HORIZONTAL) {
					barSprite.graphics.moveTo(0, barOrder[i] * barH);
					barSprite.graphics.lineTo(barW, barOrder[i] * barH);
				}else {
					barSprite.graphics.moveTo(barOrder[i]*barW, 0);
					barSprite.graphics.lineTo(barOrder[i]*barW, barH);
				}
			}
			oldn = i;
		}
		private function transitionCompleted():void {
			current.removeChild(current.mask);
			current.mask = null;
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(tweenObject);
			transitionCompleted();
		}
		
	}
	
}