﻿package transitions 
{
	import caurina.transitions.Tweener;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.GradientType;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	/**
	$(CBI)* ...
	$(CBI)* @author ...
	$(CBI)*/
	public class ShapesTransition extends Transition 
	{
		
		private var current:Sprite;
		private var old:Sprite;
		private var rowAmount:Number;
		public function ShapesTransition(current:Sprite, old:Sprite, shape:DisplayObject, rowAmount:Number = 10, time:Number = 1, multiplier:Number = 1,rotate:Number=0,direction:String=TransitionManager.NONE, startAlpha:Number = 1) 
		{
			this.current = current;
			this.old = old;
			this.rowAmount = rowAmount;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			if (!shape) {
				dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
				return;
			}
			var curMask:Sprite = new Sprite();
			current.addChild(curMask);
			curMask.cacheAsBitmap = true;
			current.mask = curMask;
			current.alpha = startAlpha;
			var height:Number = Math.ceil(TransitionManager.transitionAreaHeight / Math.max((rowAmount-1),1)); 
			shape.scaleX =  shape.scaleY = height / shape.height;
			var width:Number = shape.width;
			var colAmount:Number = Math.ceil(TransitionManager.transitionAreaWidth / width);
			var matrix:Matrix = new Matrix();
			matrix.scale(shape.scaleX, shape.scaleY);
			var bitmapData:BitmapData = new BitmapData(width, height,true,0x00000000);
			bitmapData.draw(shape, matrix);
			
			shape.scaleX =  shape.scaleY = 1;
			
			var t:Number = time;
			var d:Number = 0;
			if (direction == TransitionManager.DOWN || direction == TransitionManager.UP) {
				d = (time / (rowAmount+1));
				t = d * 2;
			}else if (direction == TransitionManager.LEFT || direction == TransitionManager.RIGHT) {
				d = (time / (colAmount+1));
				t = d * 2;
			}
			for (var i:uint = 0; i < rowAmount; i++) {
				for (var j:uint = 0; j < colAmount; j++) {
					var bitmap:Bitmap = new Bitmap(bitmapData,"auto",true);
					bitmap.y = -bitmap.height/2;
					bitmap.x = -bitmap.width / 2;
					
					var pivot:Sprite = new Sprite();
					pivot.y = i * height + bitmap.height/2;
					pivot.x = j * width + bitmap.width / 2;
					pivot.addChild(bitmap);
					curMask.addChild(pivot);
					pivot.scaleX = 0;
					pivot.scaleY = 0;
					var delay:Number = 0;
					
					if (direction == TransitionManager.DOWN) {
						delay = d * i;
					}else if (direction == TransitionManager.UP) {
						delay = d * (rowAmount - i -1);
					}else if (direction == TransitionManager.LEFT) {
						delay = d * (colAmount - j -1);
					}else if (direction == TransitionManager.RIGHT) {
						delay = d * j;
					}else {
						delay = 0;
					}
					Tweener.addTween(pivot, { scaleX:multiplier, scaleY:multiplier,rotation:rotate*360,delay:delay, time:t, transition:"linear"});
				}
			}
			Tweener.addTween(current, { alpha:1,time:time, transition:"linear",onComplete:transitionCompleted});
			
		}
		private function transitionCompleted():void {
			current.removeChild(current.mask);
			current.mask = null;
			current.alpha = 1;
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			var curMask:Sprite = Sprite(current.mask);
			for (var i:uint; i < curMask.numChildren; i++) {
				Tweener.removeTweens(curMask.getChildAt(i));
			}
			Tweener.removeTweens(current);
			Tweener.removeTweens(current.mask);
			transitionCompleted();
		}
		
		
	}
	
}