﻿package transitions 
{
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	
	import tools.Statics;
	import gallery.TransitionObject;
	

	public class TransitionManager 
	{
		
		[Embed("../pixelBender/ContrastFilter.pbj" , mimeType="application/octet-stream")]
		public static var contrastFilter:Class;
		
		
		public static const types:Array = ["Alpha","Reveal","Circle","RandomBars","TriangleReveal","Slide","Move","Stretch",
											"Split","Blinds","MultiReveal","Fade","Pixelated","Explode","Static","Sweep","Contrast","Blur"];
		public static const directions:Array = ["UP","DOWN","LEFT","RIGHT","UPLEFT","DOWNLEFT","UPRIGHT","DOWNRIGHT"];
		public static const directions2:Array = ["IN","OUT"];
		public static const directions3:Array = ["UP","DOWN","LEFT","RIGHT","LEFTRIGHT","UPDOWN","CENTER"];
		public static const directions4:Array = ["UP","DOWN","LEFT","RIGHT","NONE"];
		public static const subTypes:Array = ["HORIZONTAL","VERTICAL"];
		
		public static const Alpha:String = "Alpha";
		public static const Reveal:String = "Reveal";
		public static const Circle:String = "Circle";
		public static const RandomBars:String = "RandomBars";
		public static const TriangleReveal:String = "TriangleReveal";
		public static const Slide:String = "Slide";
		public static const Move:String = "Move";
		public static const Stretch:String = "Stretch";
		public static const Split:String = "Split";
		public static const Shapes:String = "Shapes";
		public static const Blinds:String = "Blinds";
		public static const MultiReveal:String = "MultiReveal";
		public static const Fade:String = "Fade";
		public static const Pixelated:String = "Pixelated";
		public static const Explode:String = "Explode";
		public static const Static:String = "Static";
		public static const Sweep:String = "Sweep";
		public static const Contrast:String = "Contrast";
		public static const Blur:String = "Blur";
		public static const Random:String = "Random";
		
		public static const UP:String = "UP";
		public static const DOWN:String = "DOWN";
		public static const LEFT:String = "LEFT";
		public static const RIGHT:String = "RIGHT";
		public static const UPLEFT:String = "UPLEFT"
		public static const DOWNLEFT:String = "DOWNLEFT";
		public static const UPRIGHT:String = "UPRIGHT";
		public static const DOWNRIGHT:String = "DOWNRIGHT";
		public static const UPDOWN:String = "UPDOWN";
		public static const LEFTRIGHT:String = "LEFTRIGHT";
		public static const CENTER:String = "CENTER";
		
		public static const HORIZONTAL:String = "HORIZONTAL";
		public static const VERTICAL:String = "VERTICAL";
		
		public static const CIRCLES:String = "CIRCLES";
		public static const HEARTS:String = "HEARTS";
		public static const CUSTOM:String = "CUSTOM";
		
		public static const WIPE:String = "WIPE";
		public static const NONE:String = "NONE";
		
		public static const IN:String = "IN";
		public static const OUT:String = "OUT";
		
		
		private static var transitionList:Array = new Array();
		private static var transition:Transition;
		
		public static var onComplete:Function;
		
		public static var transitionAreaWidth:Number = 400;
		public static var transitionAreaHeight:Number = 300;
		
		public function TransitionManager() 
		{
			trace("This class is static");
		}
		public static function addTransition(current:Sprite, old:Sprite, transitionObject:TransitionObject, onCompl:Function = null):void {
			if (transition) {
				transition.completeTransition();
			}
			
			var type:String = ((transitionObject.type == null) ? NONE : transitionObject.type);
			var time:Number = ((isNaN(transitionObject.time)) ? 1 : transitionObject.time);
			var direction:String = ((transitionObject.direction == null) ? LEFT : transitionObject.direction);
			var subtype:String = ((transitionObject.subtype == null) ? HORIZONTAL : transitionObject.subtype);
			var effect:Number = ((isNaN(transitionObject.effect)) ? 0 : transitionObject.effect);
			var amount:Number = ((isNaN(transitionObject.amount)) ? 100 : transitionObject.amount);
			var startAlpha:Number = ((isNaN(transitionObject.startAlpha)) ? 1 : transitionObject.startAlpha);
			var shape:DisplayObject = Statics.shapeLoader.getObject(transitionObject.shapeURL);
			var multiplier:Number = ((isNaN(transitionObject.multiplier)) ? 1 : transitionObject.multiplier);
			var rotate:Number = ((isNaN(transitionObject.rotate)) ? 0 : transitionObject.rotate);
			var color:uint = ((isNaN(transitionObject.color)) ? 0xFFFFFF : transitionObject.color);
			var delay:Number = ((isNaN(transitionObject.delay)) ? 3 : transitionObject.delay);
			var size:Number = ((isNaN(transitionObject.size)) ? 40 : transitionObject.size);
			onComplete =  onCompl;
			
			if (transitionObject.type == Random){
				type = types[Math.min(Math.floor(Math.random() * types.length),types.length-1)];
				direction = directions[Math.min(Math.floor(Math.random() * 4),3)];
				effect = Math.min(Math.floor(Math.random() * 2),1);
				subtype = subTypes[Math.min(Math.floor(Math.random() * 2),1)];
				amount = Math.ceil(Math.random() * 20);
			} 
			
			if (type == Alpha) {
				transition= new AlphaTransition(current, old,time);	
			}else if (type == Reveal) {
				if (transitionObject.type == Random){
					direction = directions[Math.min(Math.floor(Math.random() * 8),7)];
				}
				transition= new RevealTransition(current, old,direction,effect,time,startAlpha );
			}else if (type == Circle) {
				transition= new CircleTransition(current, old,effect,time,startAlpha );
			}else if (type == RandomBars) {
				transition= new RandomBarsTransition(current, old,subtype,amount,time);
			}else if (type == TriangleReveal) {
				transition= new TriangleRevealTransition(current, old,subtype,effect,time,startAlpha);
			}else if (type == Slide) {
				transition= new SlideTransition(current, old,direction,time,startAlpha);
			}else if (type == Split) {
				if (transitionObject.type == Random){
					direction = directions2[Math.min(Math.floor(Math.random() * 2),1)];
				}else{
					direction = ((transitionObject.direction == null) ? OUT : transitionObject.direction);
				}
				transition= new SplitTransition(current, old,subtype,direction,effect,time,startAlpha);
			}else if (type == Move) {
				transition= new MoveTransition(current, old,direction,time,startAlpha);
			}else if (type == Stretch) {
				if (transitionObject.type == Random){
					direction = directions3[Math.min(Math.floor(Math.random() * 7),6)];
				}
				transition= new StretchTransition(current, old,direction,time,startAlpha);
			}else if (type == Blinds) {
				amount = ((isNaN(transitionObject.amount)) ? 10 : transitionObject.amount);
				transition= new BlindsTransition(current, old,subtype,amount,effect,delay,time,startAlpha);
			}else if (type == MultiReveal) {
				transition= new MultiRevealTransition(current, old,direction,time,startAlpha );
			}else if (type == Fade) {
				transition= new FadeTransition(current, old,color,time );
			}else if (type == Pixelated) {
				if (transitionObject.type == Random){
					direction = directions4[Math.min(Math.floor(Math.random() * 5),4)];
				}
				direction = ((transitionObject.direction == null) ? NONE : transitionObject.direction);
				transition= new PixelatedTransition(current, old,direction,size,time );
			}else if (type == Shapes) {
				direction = ((transitionObject.direction == null) ? NONE : transitionObject.direction);
				amount = ((isNaN(transitionObject.amount)) ? 10 : transitionObject.amount);
				transition= new ShapesTransition(current, old,shape,amount,time,multiplier,rotate,direction,startAlpha);
			}
			else if (type == Explode) {
				var rowAmount:Number = ((isNaN(transitionObject.rowAmount)) ? 8 : transitionObject.rowAmount);
				var colAmount:Number = ((isNaN(transitionObject.colAmount)) ? 8 : transitionObject.colAmount);
				var velocityXMin:Number = ((isNaN(transitionObject.velocityXMin)) ? -5 : transitionObject.velocityXMin);
				var velocityYMin:Number = ((isNaN(transitionObject.velocityYMin)) ? -20 : transitionObject.velocityYMin);
				var velocityXMax:Number = ((isNaN(transitionObject.velocityXMax)) ? 5 : transitionObject.velocityXMax);
				var velocityYMax:Number = ((isNaN(transitionObject.velocityYMax)) ? -10 : transitionObject.velocityYMax);
				var gravity:Number = ((isNaN(transitionObject.gravity)) ? 2 : transitionObject.gravity);
				transition= new ExplodeTransition(current,old,rowAmount,colAmount,velocityXMin,velocityXMax,velocityYMin,velocityYMax,gravity);
			}else if (type == Static) {
				var smooth:Number = ((isNaN(transitionObject.smooth)) ? 1 : transitionObject.smooth);
				transition= new StaticTransition(current, old,smooth,time);	
			}else if (type == Sweep) {
				rowAmount = ((isNaN(transitionObject.rowAmount)) ? 8 : transitionObject.rowAmount);
				colAmount = ((isNaN(transitionObject.colAmount)) ? 8 : transitionObject.colAmount);
				effect = ((isNaN(transitionObject.effect)) ? 1 : transitionObject.effect);
				subtype = ((transitionObject.subtype == null) ? "1" : transitionObject.subtype);
				transition= new SweepTransition(current, old,direction,rowAmount,colAmount,subtype,effect,time);	
			}else if (type == Contrast) {
				amount = ((isNaN(transitionObject.amount)) ? 5 : transitionObject.amount);
				transition= new ContrastTransition(current, old,amount,time );
			}else if (type == Blur) {
				var blurX:Number = ((isNaN(transitionObject.blurX)) ? 20 : transitionObject.blurX);
				var blurY:Number = ((isNaN(transitionObject.blurY)) ? 20 : transitionObject.blurY);
				var quality:Number = ((isNaN(transitionObject.quality)) ? 2 : transitionObject.quality);
				transition= new BlurTransition(current, old,blurX,blurY,quality,time );
			}else {
				transitionCompleted(null);
				return;
			}
			transition.addEventListener(TransitionEvent.TransitionCompleted, transitionCompleted);
		}
		public static function removeTransition():void{
			if (transition) {
				transition.completeTransition();
			}
		}
		private static function transitionCompleted(e:TransitionEvent):void {
			if(transition){
				transition.removeEventListener(TransitionEvent.TransitionCompleted, transitionCompleted);
			}
			transition = null;
			if(onComplete != null)
				onComplete();
		}
		
	}
	
}