﻿package transitions 
{
	import caurina.transitions.Tweener;
	import flash.display.GradientType;
	import flash.display.Sprite;
	import flash.geom.Matrix;
	/**
	$(CBI)* ...
	$(CBI)* @author ...
	$(CBI)*/
	public class TriangleRevealTransition extends Transition 
	{
		
		private var current:Sprite;
		private var old:Sprite;
		public function TriangleRevealTransition(current:Sprite,old:Sprite,subtype:String=TransitionManager.HORIZONTAL,effect:Number=0,time:Number=1,startAlpha:Number=1) 
		{
			this.current = current;
			this.old = old;
			if(old&&current.parent.getChildIndex(current)<current.parent.getChildIndex(old))
				current.parent.swapChildren(current, old);
			
			var curMask:Sprite = new Sprite();
			var topleft:Sprite = new Sprite();
			var downright:Sprite = new Sprite();
			topleft.graphics.lineStyle(0, 0, 0);
			downright.graphics.lineStyle(0, 0, 0);
			if(effect==1){
				var topleftmatrix:Matrix = new Matrix();
				var downrightmatrix:Matrix = new Matrix();
				if(subtype==TransitionManager.HORIZONTAL){
					topleftmatrix.createGradientBox(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight, 0, 0, 0);
					downrightmatrix.createGradientBox(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight, Math.PI, 0, 0);
				}else {
					topleftmatrix.createGradientBox(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight,  Math.PI / 2, 0, 0);
					downrightmatrix.createGradientBox(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight, -Math.PI / 2, 0, 0);
				}
				topleft.graphics.beginGradientFill(GradientType.LINEAR, [0x000000, 0x000000], [1, 0], [200, 255], topleftmatrix);
				downright.graphics.beginGradientFill(GradientType.LINEAR, [0x000000, 0x000000], [1, 0], [200, 255], downrightmatrix);
			}else {
				topleft.graphics.beginFill(0x000000, 1);
				downright.graphics.beginFill(0x000000, 1);
			}
			
			if (subtype == TransitionManager.HORIZONTAL) {
				topleft.graphics.moveTo(0, -TransitionManager.transitionAreaHeight / 2);
				topleft.graphics.lineTo(0, 3 * TransitionManager.transitionAreaHeight / 2);
				topleft.graphics.lineTo(TransitionManager.transitionAreaWidth, TransitionManager.transitionAreaHeight / 2);
				topleft.graphics.lineTo(0, -TransitionManager.transitionAreaHeight / 2);
				
				downright.graphics.moveTo(TransitionManager.transitionAreaWidth, -TransitionManager.transitionAreaHeight / 2);
				downright.graphics.lineTo(TransitionManager.transitionAreaWidth, 3 * TransitionManager.transitionAreaHeight / 2);
				downright.graphics.lineTo(0, TransitionManager.transitionAreaHeight / 2);
				downright.graphics.lineTo(TransitionManager.transitionAreaWidth, -TransitionManager.transitionAreaHeight / 2);
			}else {
				topleft.graphics.moveTo(-TransitionManager.transitionAreaWidth/2, 0);
				topleft.graphics.lineTo(3 *TransitionManager.transitionAreaWidth/2, 0);
				topleft.graphics.lineTo(TransitionManager.transitionAreaWidth/2, TransitionManager.transitionAreaHeight);
				topleft.graphics.lineTo(-TransitionManager.transitionAreaWidth/2, 0);
				
				downright.graphics.moveTo(-TransitionManager.transitionAreaWidth/2, TransitionManager.transitionAreaHeight);
				downright.graphics.lineTo(3 *TransitionManager.transitionAreaWidth/2, TransitionManager.transitionAreaHeight);
				downright.graphics.lineTo(TransitionManager.transitionAreaWidth/2, 0);
				downright.graphics.lineTo(-TransitionManager.transitionAreaWidth/2, TransitionManager.transitionAreaHeight);
			}
			
			topleft.graphics.endFill();
			downright.graphics.endFill();
			curMask.addChild(topleft);
			curMask.addChild(downright);
			
			current.addChild(curMask);
			curMask.cacheAsBitmap = true;
			current.mask = curMask;
			current.alpha = startAlpha;
			
			if (subtype == TransitionManager.HORIZONTAL) {
				topleft.x = -TransitionManager.transitionAreaWidth;
				downright.x = TransitionManager.transitionAreaWidth;
				Tweener.addTween(topleft, { x:0, time:time, transition:"linear"  } );
				Tweener.addTween(downright, { x:0, time:time, transition:"linear"  } );
			}else{
				topleft.y = -TransitionManager.transitionAreaHeight;
				downright.y = TransitionManager.transitionAreaHeight;
				Tweener.addTween(topleft, { y:0, time:time, transition:"linear"  } );
				Tweener.addTween(downright, { y:0, time:time, transition:"linear"  } );
			}
			Tweener.addTween(current, { alpha:1, time:time, transition:"linear",onComplete:transitionCompleted });
			
		}
		private function transitionCompleted():void {
			current.removeChild(current.mask);
			current.mask = null;
			current.alpha = 1;
			if (old) {
				old.visible = false;
			}
			dispatchEvent(new TransitionEvent(TransitionEvent.TransitionCompleted, current,old));
		}
		public override function completeTransition():void {
			Tweener.removeTweens(current);			
			transitionCompleted();
		}
		
	}
	
}